<template>
	<div>
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<BlankLayout>
			<template slot="head">
				<CommonHeader :showBackButton="true" :title="$t('locations')"></CommonHeader>
			</template>
			<template slot="body">
				<div class="content-location">
					<div class="content-title">
						<p>{{$t('chooseOrAddAdress')}}</p>
					</div>
					<div>
						<div class="card" @click="currentLocation()">
							<div class="ubicacion">
								<div class="ubicacion-icon">
									<div class="circle-icon">
										<i class="fa fa-paper-plane"></i>
									</div>
								</div>
								<div class="ubicacion-text">
									<div class="ubicacion-text-content">
										<p>{{$t('currentLocation')}}</p>
									</div>
								</div>
							</div>
						</div>
						<br>
						<div class="card" v-for="address in addressBook" :key="address.id" @click="updateOrSelect(address.id)">
							<div class="ubicacion">
								<div class="ubicacion-icon">
									<i class="fa fa-crosshairs"></i>
								</div>
								<div class="ubicacion-text">
									<div class="ubicacion-text-content">
										<!-- <p>{{$t('location')}}</p> -->
										<span>{{address.formatAddress}}</span>
									</div>
									<div v-if="address.defaultAddress" class="ubicacion-select">
										<i class="fa fa-check"></i>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="send-container">
					<BeeInput @click="addAddress" class="send-button"> 
						<i class="fa fa-map-marker"></i>
						{{$t('addAddress')}}
					</BeeInput>
				</div>
				<Modal v-if="modalUpdateOrSelect" :ShowClose="false">
					<div class="card-modal">
						<p>
							<b>{{ $t('selectOrUpdate') }}</b>
						</p>
						<div class="card-actions">
							<button @click="updateAddress()">{{ $t('update') }}</button>
							<button @click="select()">{{ $t('select') }}</button>
						</div>
					</div>
				</Modal>
			</template>
		</BlankLayout>
	</div>	
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import BeeInput from '@/components/BeeInput.vue'
import BlankLayout from '@/layouts/BlankLayout.vue'
import { User } from '@/models/User'
import AddressService from '@/services/AddressService'
import { DeliveryMenu } from '@/models/DeliveryMenu'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import Modal from '@/components/Modal.vue'

@Component({
	components: {
		BlankLayout,
		CommonHeader,
		BeeInput,
		SpinnerHolder,
		Modal
	},
})
export default class Locations extends Vue {
	loading = false;
	user: User = this.$store.state.user;
	locationRes = this.$store.state.deliveryMenu as DeliveryMenu
	lat = String(this.locationRes.location?.lat)
	lng = String(this.locationRes.location?.lng)
	modalUpdateOrSelect = false
	idAddress = ''
	config = {
		headers: {
			Authorization: this.user.authToken,
		}
	};
	addressBook = []

    addAddress(){
        this.$router.push({ name: 'location', params: {
			lat: this.lat, 
			lng: this.lng, 
			length: String(this.addressBook.length)
		}})
    }

	async updateOrSelect(idAddress: string){
		this.idAddress = idAddress
		this.modalUpdateOrSelect = true
	}

	async getAddressBook(){
		this.loading = true;
		const request = await AddressService.getAllAddressBook()
		this.addressBook = request?.data
	}

	async created() {
		this.loading = true
		if(this.user.authToken) {
			await this.getAddressBook();
		}
		navigator.geolocation.getCurrentPosition(res => {
			this.lat = String(res.coords.latitude);
			this.lng = String(res.coords.longitude);
		})
		this.loading = false
	}

	async select(){
		this.loading = true
		const request = await AddressService.getAddressBookById(this.idAddress)
		if(request) {
			const address = request.data
			address.defaultAddress = true
			await AddressService.updateAddressBook(this.idAddress, address)
		}
		this.loading = false
		this.$router.push('/summary')
	}

	async updateAddress(){
		this.$router.push({ name: 'location', params: {
			idAddress: this.idAddress, 
			lat: this.lat, 
			lng: this.lng
		}})
	}

	async currentLocation(){
		this.$router.push({ name: 'location', params: {
			lat: this.lat, 
			lng: this.lng,
			length: String(this.addressBook.length)
		}})
	}
}
</script>

<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}
.content-location {
	padding: 1em 1em 5em;
	box-sizing: border-box;
	.content-title {
		font-weight: bold;
		font-size: 24px;
		line-height: 28px;
	}
}
.card {
	background: #ffffff;
	box-shadow: 0px 1px 4px rgba(0, 0, 0, 0.25);
	border-radius: 7px;
	padding: 1em;
	margin-top: 5px;
	.ubicacion {
		display: -webkit-box;
		margin-top: 0.5em;
		.ubicacion-icon {
			.fa-crosshairs {
				margin-top: 7.5px;
				font-size: 1.5em;
				width: 30px;
				text-align: center;
			}
			.circle-icon {
				padding: 0.5em;
				border-radius: 30px;
				background-color: #0045e7;
				color: white;
				text-align: center;
			}
		}
		.ubicacion-text {
			width: 100%;
			display: flex;
			padding: 0 1em;
			.ubicacion-text-content {
				width: 80%;
				p {
					font-size: 16px;
					line-height: 24px;
					color: #303030;
					margin: 0px;
					font-weight: bold;
				}
				span {
					font-size: 14px;
					line-height: 21px;
					color: #828282;
					font-weight: normal;
				}
			}

			.ubicacion-select {
				.fa-check {
					margin-bottom: 15px;
					margin-left: 5px;
					right: 5px;
					color: #2ed775;
				}
				align-self: flex-end;
			}
		}
	}
}
.send-container {
	width: 100%;
	padding: 0.5em;
	background: #ffffff;
	box-shadow: 0px -1px 41px rgba(0, 0, 0, 0.15);
	position: fixed;
	bottom: 0px;
	.send-button {
		margin: auto;
		width: 90%;
		height: 50px;
		font-weight: 500;
		font-size: 18px;
		line-height: 27px;

		i{
			padding-right: 8px;
		}
	}
}
.card-modal {
	p {
		color: #232323;
		font-weight: 500;
		font-size: 16px;
		line-height: 24px;
		text-align: center;
	}
	.card-actions {
		padding: 1em 0.5em;
		button:first-child {
			background: #e0e0e0;
			color: #828282;
		}
		button {
			font-weight: 500;
			font-size: 18px;
			line-height: 27px;
			text-align: center;
			border-radius: 6px;
			height: 46px;
			border: none;
			width: 38%;
			margin: 0 0.5em;
			background: #2ed775;
			color: #ffffff;
		}
	}
}
</style>